/*
The UK Tax Freedom Clock v2.0 (2008)
Copyright 2009 John Gaver
License: Freeware
http://www.ActionAmerica.org/
v2.0 matches v2.0 of the US Tax Freedom Clock and adds automatic internet updating of the UK Tax Freedom Day date.
*/

var timerInterval = null;
var daysInMon = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

function setup()
{
	if (window.widget) {
		widget.onhide = onhide;
		widget.onshow = onshow;
	}

	createGenericButton(document.getElementById('done'), 'Back', hidePrefs);
	flipShown = false;
	onshow();
}

function onshow() {
    if (timerInterval == null) {
        timerInterval = setInterval("getClock();", 1000);
    }
	var tfdraw = new XMLHttpRequest();
    tfdraw.open("GET", "http://www.actionamerica.org/taxecon/uktaxfreedomday.txt",true);
	tfdraw.setRequestHeader("Cache-Control", "no-cache"); 
	tfdraw.onreadystatechange=function() {
		if (tfdraw.readyState==4) {
			tfd = tfdraw.responseText;
            tfdate = new Date(tfd);
            tfddatestr = tfdate.toDateString();
            tfdtimestr = tfdate.toTimeString();
            tfddatestr = tfddatestr.substring(4,11);
            tfmon = tfdate.getMonth();
            pretfmon = tfmon - 1;
            ticsintfm = daysInMon[tfmon] * 86400000;
            ticsinpretfm = daysInMon[tfmon - 1] * 86400000;
		}
	}    
	tfdraw.send(null);
	getClock();
}

function onhide() {
    if (timerInterval != null) {
        clearInterval(timerInterval);
        timerInterval = null;
    }
}

function tfdays (today, tfday) {
    diff = new Date();
    diff.setTime(Math.abs(tfday.getTime() - today.getTime()));
    timediff = diff.getTime();
    ticsinday = 86400000;
    nowmon = today.getMonth();
    months = 0;

    if (tfday >= today) {
        while (timediff > ticsinpretfm) {
            timediff = timediff - (daysInMon[nowmon] * ticsinday);
            months = months + 1;
            nowmon = nowmon + 1;
        }
    }
    else {
        while (timediff > ticsintfm) {
            timediff = timediff - (daysInMon[nowmon - 1] * ticsinday);
            months = months + 1;
            nowmon = nowmon - 1;
        }
    }

    if (months < 10) {
        months = months.toString();
        months = "0" + months; }

    days = Math.floor(timediff / (1000 * 60 * 60 * 24)); 
    timediff -= days * (1000 * 60 * 60 * 24);
    if (days < 10) {
        days = days.toString();
        days = "0" + days; }

    hours = Math.floor(timediff / (1000 * 60 * 60)); 
    timediff -= hours * (1000 * 60 * 60);
    if (hours < 10) {
        hours = hours.toString();
        hours = "0" + hours; }

    mins = Math.floor(timediff / (1000 * 60)); 
    timediff -= mins * (1000 * 60);
    if (mins < 10) {
        mins = mins.toString();
        mins = "0" + mins; }

    secs = Math.floor(timediff / 1000); 
    timediff -= secs * 1000;
    if (secs < 10) {
        secs = secs.toString();
        secs = "0" + secs; }
        
    difference = months + " : " + days + " : " + hours + " : " + mins + " : " + secs;

    return difference;
}

function getClock() {
    var now = new Date();
	nowyr = (now.getFullYear());
    tfdy = new Date(tfddatestr + " " + nowyr + " " + tfdtimestr);
    document.getElementById("bg").innerText = tfdays(now, tfdy); 
    document.getElementById("toptxt").innerText = getTop(now, tfdy); 
} 

function getTop(today, tfd) {
    if (today <= tfd) {
        toptx = "Time till Brits start earning money for themselves this year:";
    }
    else {
        toptx = "Brits have only been earning money for themselves this year for:"
    }
    return toptx;
}

window.onload = getClock; 

function goToUrl(url)
{
	if (window.widget)
	{
		widget.openURL(url);
	}
}

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	resizedWhenFlippedOver = false;
	if (window.widget) {
		window.resizeTo (200, 240);
		resizedWhenFlippedOver = true;
		widget.prepareForTransition("ToBack");
	}

	front.style.display="none";
	back.style.display="block";

	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);  
	}

	document.getElementById('fliprollie').style.display = 'none';
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");
      
	back.style.display="none";
	front.style.display="block";

	resizedWhenFlippedOver = true;
	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);
		window.resizeTo (200, 95);
		resizedWhenFlippedOver = false;
	}

	flipShown = false;
	flipfwd();
}

var flipShown = false;
var animation = {duration:500, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function flipfwd()
{
	// fade in the info button
	if (animation.timer != null)
	{
		clearInterval (animation.timer);
		animation.timer  = null;
	}
 
	var starttime = (new Date).getTime() - 13;
 
	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate();", 13);
	animation.from = animation.now;
	animation.to = 0.0;
	animate();
	flipShown = false;
	
	event.stopPropagation();
	event.preventDefault();
}

function mousemove (event)
{
	if (!flipShown)
	{
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
	
	event.stopPropagation();
	event.preventDefault();
}

function mouseexit (event)
{
	if (flipShown)
	{
		// fade out the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
	
	event.stopPropagation();
	event.preventDefault();
}
function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
   

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
	document.getElementById('flip').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}
